// Copyright (C) 2002 Hewlett-Packard Company
// All rights reserved.
//
/* PORTCHECK OFF */
/****************************************************************************
 $Header: /cvsroot/mapisp/src/OMName/omname.h,v 1.1.1.1 2002-11-21 17:55:32 gren Exp $
 Prototypes for the API
 ****************************************************************************/

#ifndef OMNAME_INCLUDED

#define OMNAME_INCLUDED

#include "omnerr.h"

#ifndef RC_INVOKED

#include "omnnos.h"
#include "types8.h"

omcnAPI omcnVersion(
	UCHAR PARM_PTR	szVersion,
	const int		nSize,
	WORD PARM_PTR	pwVersion);

omcnAPI omcnParseFormatString(
	const UCHAR PARM_PTR	szFormatString,
	omcnFormatPtr			pFormat);

omcnAPI omcnChangeOutputFormat(
	const UCHAR PARM_PTR	szFormatString,
	omcnFormatPtr			pFormat);

omcnAPI omcnChangeInputFormat(
	const UCHAR PARM_PTR	szFormatString,
	omcnFormatPtr			pFormat);

omcnAPI omcnGetRSList(
	const omcnFormatPtr	pFormat,
	UCHAR PARM_PTR		pBuffer,
	const unsigned int	uBufferLen);

omcnAPI omcnGetErrorText(
	const omcnError		nError,
	UCHAR PARM_PTR		pBuffer,
	const unsigned int	uBufferLen);

omcnAPI omcnValidateAttribute(
	const UCHAR PARM_PTR	szValue,
    const unsigned int		uMaxLen,
	const omcnAttributeID	nID);

omcnAPI omcnTranslateInternalFormat(
	omcnFormatPtr			pFormat,
	const omcnInternalType	nSrcInternal,
	const UCHAR PARM_PTR	_szSrcInternal,
	const omcnInternalType	nDestInternal,
	UCHAR PARM_PTR			pDest,
	const unsigned int		uLen,
	const UINT16			wFlags);

omcnAPI omcnParseName(
	const UCHAR PARM_PTR	szFormattedName,
	omcnFormatPtr			pFormat,
	const omcnInternalType	nInternal,
	UCHAR PARM_PTR			pBuffer,
	const unsigned int		uLen,
	UINT32 PARM_PTR			_pwAlts,
	const UINT16			wFlags);

omcnAPI omcnFormatName(
	const omcnFormatPtr		pFormat,
	UCHAR PARM_PTR			pBuffer,
	const unsigned int		uLen,
	const UINT16			wFlags);

omcnAPI omcnGetAttributeValue(
	const omcnFormatPtr		pFormat,
    const omcnAttributeID	nAttribute,
	omcnStringPtr			pBuffer,
	const UINT16			uSize);

omcnAPI omcnGetFormatInfo(
	const omcnFormatPtr	pFormat,
	LPVOID				pData,
    const UINT16		uSize,
	const UINT16		uDataType);

omcnAPI omcnSetFormatInfo(
	omcnFormatPtr		pFormat,
	const LPVOID		pData,
	const UINT16		uDataType);

/* Martin's public wrappers for the existing validator functions */

omcnAPI omcnValidatePString(
	const UCHAR PARM_PTR	szValue,
	const int			    uMaxLen);

omcnAPI omcnValidateNString(
	const UCHAR PARM_PTR	szValue,
	const int			    uMaxLen);

omcnAPI omcnValidateString(
	const UCHAR PARM_PTR	szValue,
	const int			    uMaxLen,
	BOOL PARM_PTR		    pbNotIA5);

omcnAPI omcnValidateTeletexOrPString(
	const UCHAR PARM_PTR	szValue,
	const int			    uMaxLen,
	BOOL PARM_PTR		    pbNotPrintable);

/* Internet address functions */

BOOL omcnParseInternetName(
	UCHAR PARM_PTR			szAddress,
	UCHAR PARM_PTR			szName);

BOOL omcnIsGSETBInternetName(
	UCHAR PARM_PTR			szBuffer);

#endif /*RC_INVOKED*/

#endif /*OMNAME_INCLUDED*/
